Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Parser/SymbolTable.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Parser/SymbolTable.cs	(revision 14327)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Parser/SymbolTable.cs	(revision 14328)
@@ -1,5 +1,4 @@
 ﻿using System;
 using System.Collections.Generic;
-using System.Linq;
 
 namespace HeuristicLab.Algorithms.PushGP
@@ -10,68 +9,156 @@
         {
             #region Code
-            { "CODE.NOOP", OpCode.CodeNoop },
-            { "CODE.PUSH", OpCode.CodePush },
-            { "CODE.IF", OpCode.CodeIf },
-            { "CODE.DEFINE", OpCode.CodeDefine },
-            { "CODE.DUP", OpCode.CodeDup },
-            { "CODE.QUOTE", OpCode.CodeQuote },
-            { "CODE.DO", OpCode.CodeDo },
+            { Symbols.CodeIf, OpCode.CodeIf },
+            { Symbols.CodeDefine, OpCode.CodeDefine },
+            { Symbols.CodeDuplicate, OpCode.CodeDuplicate },
+            { Symbols.CodeQuote, OpCode.CodeQuote },
+            { Symbols.CodeDo, OpCode.CodeDo },
+            { Symbols.CodeEquals, OpCode.CodeEquals },
+            { Symbols.CodeAppend, OpCode.CodeAppend },
+            { Symbols.CodeAtom, OpCode.CodeAtom },
+            { Symbols.CodeCar, OpCode.CodeCar },
+            { Symbols.CodeCdr, OpCode.CodeCdr },
+            { Symbols.CodeCons, OpCode.CodeCons },
+            { Symbols.CodeContainer, OpCode.CodeContainer },
+            { Symbols.CodeContains, OpCode.CodeContains },
+            { Symbols.CodeDefinition, OpCode.CodeDefinition },
+            { Symbols.CodeDiscrepancy, OpCode.CodeDiscrepancy },
+            { Symbols.CodeDoX, OpCode.CodeDoX },
+            { Symbols.CodeDoXCount, OpCode.CodeDoXCount },
+            { Symbols.CodeDoXRange, OpCode.CodeDoXRange },
+            { Symbols.CodeDoXTimes, OpCode.CodeDoXTimes },
+            { Symbols.CodeExtract, OpCode.CodeExtract },
+            { Symbols.CodeFlush, OpCode.CodeFlush },
+            { Symbols.CodeFromFloat, OpCode.CodeFromFloat },
+            { Symbols.CodeFromInteger, OpCode.CodeFromInteger },
+            { Symbols.CodeFromName, OpCode.CodeFromName },
+            { Symbols.CodeInsert, OpCode.CodeInsert },
+            { Symbols.CodeInstructions, OpCode.CodeInstructions },
+            { Symbols.CodeLength, OpCode.CodeLength },
+            { Symbols.CodeList, OpCode.CodeList },
+            { Symbols.CodeMember, OpCode.CodeMember },
+            { Symbols.CodeNoop, OpCode.CodeNoop },
+            { Symbols.CodeNth, OpCode.CodeNth },
+            { Symbols.CodeNthCdr, OpCode.CodeNthCdr },
+            { Symbols.CodeNull, OpCode.CodeNull },
+            { Symbols.CodePosition, OpCode.CodePosition },
+            { Symbols.CodeRand, OpCode.CodeRand },
+            { Symbols.CodeRot, OpCode.CodeRot },
+            { Symbols.CodeShove, OpCode.CodeShove },
+            { Symbols.CodeSize, OpCode.CodeSize },
+            { Symbols.CodeStackDepth, OpCode.CodeStackDepth },
+            { Symbols.CodeSubst, OpCode.CodeSubst },
+            { Symbols.CodeSwap, OpCode.CodeSwap },
+            { Symbols.CodeYank, OpCode.CodeYank },
+            { Symbols.CodeYankDuplicate, OpCode.CodeYankDuplicate },
             #endregion Code
 
             #region Exec
-            { "EXEC.EXPAND", OpCode.ExecExpand },
-            { "EXEC.PUSH", OpCode.ExecPush },
-            { "EXEC.IF", OpCode.ExecIf },
-            { "EXEC.DEFINE", OpCode.ExecDefine },
-            { "EXEC.DUP", OpCode.ExecDup },
-            { "EXEC.POP", OpCode.ExecPop },
-            { "EXEC.Y", OpCode.ExecY },
-            { "EXEC.DO*RANGE", OpCode.ExecDoXRange },
+            { Symbols.ExecIf, OpCode.ExecIf },
+            { Symbols.ExecDefine, OpCode.ExecDefine },
+            { Symbols.ExecDuplicate, OpCode.ExecDuplicate },
+            { Symbols.ExecPop, OpCode.ExecPop },
+            { Symbols.ExecY, OpCode.ExecY },
+            { Symbols.ExecDoXRange, OpCode.ExecDoXRange },
+            { Symbols.ExecEquals, OpCode.ExecEquals },
+            { Symbols.ExecDoXCount, OpCode.ExecDoXCount },
+            { Symbols.ExecDoXTimes, OpCode.ExecDoXTimes },
+            { Symbols.ExecFlush, OpCode.ExecFlush },
+            { Symbols.ExecK, OpCode.ExecK },
+            { Symbols.ExecRot, OpCode.ExecRot },
+            { Symbols.ExecS, OpCode.ExecS },
+            { Symbols.ExecShove, OpCode.ExecShove },
+            { Symbols.ExecStackDepth, OpCode.ExecStackDepth },
+            { Symbols.ExecSwap, OpCode.ExecSwap },
+            { Symbols.ExecYank, OpCode.ExecYank },
+            { Symbols.ExecYankDuplicate, OpCode.ExecYankDuplicate },
             #endregion Exec
 
             #region Name
-            { "NAME.DEFINE*EXEC", OpCode.NameDefineXExec },
-            { "NAME.POP", OpCode.NamePop },
-            { "NAME.DUP", OpCode.NameDup },
+            { Symbols.NamePop, OpCode.NamePop },
+            { Symbols.NameDuplicate, OpCode.NameDuplicate },
+            { Symbols.NameEquals, OpCode.NameEquals },
+            { Symbols.NameFlush, OpCode.NameFlush },
+            { Symbols.NameQuote, OpCode.NameQuote },
+            { Symbols.NameRand, OpCode.NameRand },
+            { Symbols.NameRandBoundName, OpCode.NameRand },
+            { Symbols.NameRot, OpCode.NameRot },
+            { Symbols.NameShove, OpCode.NameShove },
+            { Symbols.NameStackDepth, OpCode.NameStackDepth },
+            { Symbols.NameSwap, OpCode.NameSwap },
+            { Symbols.NameYank, OpCode.NameYank },
+            { Symbols.NameYankDuplicate, OpCode.NameYankDuplicate },
             #endregion Name
 
             #region Boolean
-            { "BOOLEAN.PUSH", OpCode.BooleanPush },
-            { "BOOLEAN.POP", OpCode.BooleanPop },
-            { "BOOLEAN.DUP", OpCode.BooleanDup },
-            { "BOOLEAN.AND", OpCode.BooleanAnd },
-            { "BOOLEAN.OR", OpCode.BooleanOr },
+            { Symbols.BooleanPop, OpCode.BooleanPop },
+            { Symbols.BooleanDuplicate, OpCode.BooleanDuplicate },
+            { Symbols.BooleanAnd, OpCode.BooleanAnd },
+            { Symbols.BooleanOr, OpCode.BooleanOr },
+            { Symbols.BooleanEquals, OpCode.BooleanEquals },
+            { Symbols.BooleanFlush, OpCode.BooleanFlush },
+            { Symbols.BooleanFromFloat, OpCode.BooleanFromFloat },
+            { Symbols.BooleanFromInteger, OpCode.BooleanFromInteger },
+            { Symbols.BooleanNot, OpCode.BooleanNot },
+            { Symbols.BooleanRand, OpCode.BooleanRand },
+            { Symbols.BooleanRot, OpCode.BooleanRot },
+            { Symbols.BooleanShove, OpCode.BooleanShove },
+            { Symbols.BooleanStackDepth, OpCode.BooleanStackDepth },
+            { Symbols.BooleanSwap, OpCode.BooleanSwap },
+            { Symbols.BooleanYank, OpCode.BooleanYank },
+            { Symbols.BooleanYankDuplicate, OpCode.BooleanYankDuplicate },
             #endregion Boolean
 
             #region Integer
-            { "INTEGER.PUSH", OpCode.IntegerPush },
-            { "INTEGER.POP", OpCode.IntegerPop },
-            { "INTEGER.DUP", OpCode.IntegerDup },
-            { "INTEGER.DEFINE", OpCode.IntegerDefine },
-            { "INTEGER.+", OpCode.IntegerAdd },
-            { "INTEGER.-", OpCode.IntegerSubtract },
-            { "INTEGER.*", OpCode.IntegerMultiply },
-            { "INTEGER./", OpCode.IntegerDivide },
-            { "INTEGER.<", OpCode.IntegerSmallerThan },
-            { "INTEGER.>", OpCode.IntegerGreaterThan },
-            { "INTEGER.=", OpCode.IntegerEquals },
-            { "INTEGER.MIN", OpCode.IntegerMin },
-            { "INTEGER.MAX", OpCode.IntegerMax },
+            { Symbols.IntegerPop, OpCode.IntegerPop },
+            { Symbols.IntegerDuplicate, OpCode.IntegerDuplicate },
+            { Symbols.IntegerDefine, OpCode.IntegerDefine },
+            { Symbols.IntegerAdd, OpCode.IntegerAdd },
+            { Symbols.IntegerSubtract, OpCode.IntegerSubtract },
+            { Symbols.IntegerMultiply, OpCode.IntegerMultiply },
+            { Symbols.IntegerDivide, OpCode.IntegerDivide },
+            { Symbols.IntegerSmallerThan, OpCode.IntegerSmallerThan },
+            { Symbols.IntegerGreaterThan, OpCode.IntegerGreaterThan },
+            { Symbols.IntegerEquals, OpCode.IntegerEquals },
+            { Symbols.IntegerMin, OpCode.IntegerMin },
+            { Symbols.IntegerMax, OpCode.IntegerMax },
+            { Symbols.IntegerModulo, OpCode.IntegerModulo },
+            { Symbols.IntegerFlush, OpCode.IntegerFlush },
+            { Symbols.IntegerFromBoolean, OpCode.IntegerFromBoolean },
+            { Symbols.IntegerFromFloat, OpCode.IntegerFromFloat },
+            { Symbols.IntegerRand, OpCode.IntegerRand },
+            { Symbols.IntegerRot, OpCode.IntegerRot },
+            { Symbols.IntegerShove, OpCode.IntegerShove },
+            { Symbols.IntegerStackDepth, OpCode.IntegerStackDepth },
+            { Symbols.IntegerSwap, OpCode.IntegerSwap },
+            { Symbols.IntegerYank, OpCode.IntegerYank },
+            { Symbols.IntegerYankDuplicate, OpCode.IntegerYankDuplicate },
             #endregion Integer
 
             #region Float
-            { "FLOAT.PUSH", OpCode.FloatPush },
-            { "FLOAT.POP", OpCode.FloatPop },
-            { "FLOAT.DUP", OpCode.FloatDup },
-            { "FLOAT.DEFINE", OpCode.FloatDefine },
-            { "FLOAT.+", OpCode.FloatAdd },
-            { "FLOAT.-", OpCode.FloatSubtract },
-            { "FLOAT.*", OpCode.FloatMultiply },
-            { "FLOAT./", OpCode.FloatDivide },
-            { "FLOAT.<", OpCode.FloatSmallerThan },
-            { "FLOAT.>", OpCode.FloatGreaterThan },
-            { "FLOAT.=", OpCode.FloatEquals },
-            { "FLOAT.MIN", OpCode.FloatMin },
-            { "FLOAT.MAX", OpCode.FloatMax },
+            { Symbols.FloatPop, OpCode.FloatPop },
+            { Symbols.FloatDuplicate, OpCode.FloatDuplicate },
+            { Symbols.FloatDefine, OpCode.FloatDefine },
+            { Symbols.FloatAdd, OpCode.FloatAdd },
+            { Symbols.FloatSubtract, OpCode.FloatSubtract },
+            { Symbols.FloatMultiply, OpCode.FloatMultiply },
+            { Symbols.FloatDivide, OpCode.FloatDivide },
+            { Symbols.FloatSmallerThan, OpCode.FloatSmallerThan },
+            { Symbols.FloatGreaterThan, OpCode.FloatGreaterThan },
+            { Symbols.FloatEquals, OpCode.FloatEquals },
+            { Symbols.FloatMin, OpCode.FloatMin },
+            { Symbols.FloatMax, OpCode.FloatMax },
+            { Symbols.FloatCos, OpCode.FloatCos },
+            { Symbols.FloatSin, OpCode.FloatSin },
+            { Symbols.FloatTan, OpCode.FloatTan },
+            { Symbols.FloatFromBoolean, OpCode.FloatFromBoolean },
+            { Symbols.FloatFromInteger, OpCode.FloatFromInteger },
+            { Symbols.FloatRand, OpCode.FloatRand },
+            { Symbols.FloatRot, OpCode.FloatRot },
+            { Symbols.FloatShove, OpCode.FloatShove },
+            { Symbols.FloatStackDepth, OpCode.FloatStackDepth },
+            { Symbols.FloatSwap, OpCode.FloatSwap },
+            { Symbols.FloatYank, OpCode.FloatYank },
+            { Symbols.FloatYankDuplicate, OpCode.FloatYankDuplicate },
             #endregion Float
         };
@@ -81,5 +168,5 @@
             OpCode opCode;
             if (symbolTable.TryGetValue(operationName, out opCode)) return opCode;
-            else throw new NotSupportedException("Symbol: " + operationName);
+            else throw new NotSupportedException("Operation not supported: " + operationName);
         }
 
@@ -88,13 +175,4 @@
             return symbolTable.TryGetValue(operationName, out opCode);
         }
-
-        public static string GetSymbol(OpCode opCode)
-        {
-            var symbol = symbolTable.SingleOrDefault(pair => pair.Value == opCode);
-
-            return !symbol.Equals(default(KeyValuePair<string, OpCode>))
-                ? symbol.Key
-                : null;
-        }
     }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Stack/PushGPStack.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Stack/PushGPStack.cs	(revision 14327)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Stack/PushGPStack.cs	(revision 14328)
@@ -2,12 +2,13 @@
 using System.Collections;
 using System.Collections.Generic;
+using System.Text;
 
 namespace HeuristicLab.Algorithms.PushGP.Stack
 {
     /// <summary>
-    /// While Push's stacks are generally treated as genuine stacks---that is, instructions take their arguments from the tops of
-    /// the stacks and push their results onto the tops of the stacks---a few instructions (like YANK and SHOVE) do allow direct access
+    /// While Push's stacks are generally treated as genuine stacks---that is, inclassions take their arguments from the tops of
+    /// the stacks and push their results onto the tops of the stacks---a few inclassions (like YANK and SHOVE) do allow direct access
     /// to "deep" stack elements by means of integer indices. To this extent the stacks can be used as general, random access memory
-    /// structures. This is one of the features that ensures the Turing-completeness of Push (another being the arbitrary name/value
+    /// classures. This is one of the features that ensures the Turing-completeness of Push (another being the arbitrary name/value
     /// bindings supported by the NAME data type and DEFINE methods; see below).
     /// </summary>
@@ -15,9 +16,16 @@
     public class PushGPStack<T> : IStack<T>
     {
-        private List<T> data = new List<T>();
+        private readonly List<T> data;
+        private const string delimiter = " ";
 
-        public T Top => this.data[Count - 1];
-        public int Count => data.Count;
-        public bool IsEmpty => this.Count == 0;
+        public PushGPStack(int capacity = 0)
+        {
+            this.data = new List<T>();
+        }
+
+        public T Top { get { return this.data[Count - 1]; } }
+        public int Count { get { return this.data.Count; } }
+        public int Capacity { get { return this.data.Capacity; } }
+        public bool IsEmpty { get { return this.Count == 0; } }
 
         public bool IsReadOnly
@@ -61,7 +69,6 @@
         public T Pop()
         {
-            var index = Count - 1;
-            var value = this.data[index];
-            this.data.RemoveAt(index);
+            var value = this.data[Count - 1];
+            this.data.RemoveAt(Count - 1);
 
             return value;
@@ -75,5 +82,10 @@
             this.data.RemoveRange(startIndex, count);
 
-            items.Reverse();
+            // is faster than remove range??
+            for (var i = this.Count - 1; i > startIndex - 1; i--)
+            {
+                this.data.RemoveAt(i);
+            }
+
             return items.ToArray();
         }
@@ -86,5 +98,8 @@
         public void Push(params T[] items)
         {
-            this.data.AddRange(items);
+            foreach (var item in items)
+            {
+                this.data.Add(item);
+            }
         }
 
@@ -112,5 +127,5 @@
         {
             var index = Count - 1;
-            if (this.data.Count > 0 && this.data[index].Equals(item))
+            if (this.Count > 0 && this.data[index].Equals(item))
             {
                 this.data.RemoveAt(index);
@@ -125,5 +140,5 @@
         public bool TryPop(out T item)
         {
-            if (this.data.Count > 0)
+            if (this.Count > 0)
             {
                 item = this.Pop();
@@ -144,5 +159,19 @@
         public override string ToString()
         {
-            return string.Join(", ", this.data);
+            if (this.Count == 0)
+            {
+                return string.Empty;
+            }
+
+            var sb = new StringBuilder();
+
+            for (var i = this.Count - 1; i > 0; i--)
+            {
+                sb.Append(this.data[i] + delimiter);
+            }
+
+            sb.Append(this.data[0]);
+
+            return sb.ToString();
         }
     }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Expressions/BooleanExpressionTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Expressions/BooleanExpressionTests.cs	(revision 14328)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Expressions/BooleanExpressionTests.cs	(revision 14328)
@@ -0,0 +1,10 @@
+﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+namespace HeuristicLab.Tests.Expressions
+{
+    [TestClass]
+    public class BooleanExpressionTests : InterpreterTest
+    {
+
+    }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Expressions/CodeExpressionTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Expressions/CodeExpressionTests.cs	(revision 14328)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Expressions/CodeExpressionTests.cs	(revision 14328)
@@ -0,0 +1,10 @@
+﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+namespace HeuristicLab.Tests.Expressions
+{
+    [TestClass]
+    public class CodeExpressionTests : InterpreterTest
+    {
+
+    }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Expressions/ExampleTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Expressions/ExampleTests.cs	(revision 14328)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Expressions/ExampleTests.cs	(revision 14328)
@@ -0,0 +1,256 @@
+﻿using HeuristicLab.Algorithms.PushGP.Interpreter;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+namespace HeuristicLab.Tests.Expressions
+{
+    [TestClass]
+    public class MixedExpressionTests : InterpreterTest
+    {
+        const double Delta = 0.00000001;
+
+        [TestMethod]
+        public void Example1()
+        {
+            this.interpreter.Interpret("( 2 3 INTEGER.* 4.1 5.2 FLOAT.+ TRUE FALSE BOOLEAN.OR )");
+
+            Assert.AreEqual(6, interpreter.IntegerStack.Top);
+            Assert.AreEqual(9.3, interpreter.FloatStack.Top);
+            Assert.AreEqual(interpreter.BooleanStack.Top, true);
+            Assert.IsTrue(interpreter.CodeStack.IsEmpty);
+            Assert.IsTrue(interpreter.ExecStack.IsEmpty);
+            Assert.IsTrue(interpreter.NameStack.IsEmpty);
+        }
+
+        [TestMethod]
+        public void Example2()
+        {
+            this.interpreter.Interpret("( 5 1.23 INTEGER.+ ( 4 ) INTEGER.- 5.67 FLOAT.* )");
+
+            Assert.AreEqual(1, interpreter.IntegerStack.Top);
+            Assert.AreEqual(6.9741, interpreter.FloatStack.Top);
+            Assert.IsTrue(interpreter.CodeStack.IsEmpty);
+            Assert.IsTrue(interpreter.BooleanStack.IsEmpty);
+            Assert.IsTrue(interpreter.ExecStack.IsEmpty);
+            Assert.IsTrue(interpreter.NameStack.IsEmpty);
+        }
+
+        [TestMethod]
+        public void Example3()
+        {
+            this.interpreter.Interpret("( 5 INTEGER.DUP INTEGER.+ )");
+
+            Assert.AreEqual(10, interpreter.IntegerStack.Top);
+            Assert.IsTrue(interpreter.CodeStack.IsEmpty);
+            Assert.IsTrue(interpreter.ExecStack.IsEmpty);
+            Assert.IsTrue(interpreter.NameStack.IsEmpty);
+            Assert.IsTrue(interpreter.BooleanStack.IsEmpty);
+            Assert.IsTrue(interpreter.FloatStack.IsEmpty);
+        }
+
+        [TestMethod]
+        public void Example4()
+        {
+            this.interpreter.Interpret("( 5 CODE.QUOTE ( INTEGER.DUP INTEGER.+ ) CODE.DO )");
+
+            Assert.AreEqual(10, interpreter.IntegerStack.Top);
+            Assert.IsTrue(interpreter.CodeStack.IsEmpty);
+            Assert.IsTrue(interpreter.ExecStack.IsEmpty);
+            Assert.IsTrue(interpreter.NameStack.IsEmpty);
+            Assert.IsTrue(interpreter.BooleanStack.IsEmpty);
+            Assert.IsTrue(interpreter.FloatStack.IsEmpty);
+        }
+
+        [TestMethod]
+        public void Example5()
+        {
+            this.interpreter.Interpret("( DOUBLE CODE.QUOTE ( INTEGER.DUP INTEGER.+ ) CODE.DEFINE 5 DOUBLE )");
+
+            Assert.AreEqual(10, interpreter.IntegerStack.Top);
+            Assert.IsTrue(interpreter.CodeStack.IsEmpty);
+            Assert.IsTrue(interpreter.ExecStack.IsEmpty);
+            Assert.IsTrue(interpreter.NameStack.IsEmpty);
+            Assert.IsTrue(interpreter.BooleanStack.IsEmpty);
+            Assert.IsTrue(interpreter.FloatStack.IsEmpty);
+        }
+
+        [TestMethod]
+        public void Example6()
+        {
+            this.interpreter.Interpret("( CODE.QUOTE ( INTEGER.DUP INTEGER.+ ) DOUBLE CODE.DEFINE 5 DOUBLE )");
+
+            Assert.AreEqual(10, interpreter.IntegerStack.Top);
+            Assert.IsTrue(interpreter.CodeStack.IsEmpty);
+            Assert.IsTrue(interpreter.ExecStack.IsEmpty);
+            Assert.IsTrue(interpreter.NameStack.IsEmpty);
+            Assert.IsTrue(interpreter.BooleanStack.IsEmpty);
+            Assert.IsTrue(interpreter.FloatStack.IsEmpty);
+        }
+
+        [TestMethod]
+        public void Example7()
+        {
+            this.interpreter.Interpret("( DOUBLE EXEC.DEFINE ( INTEGER.DUP INTEGER.+ ) 5 DOUBLE )");
+
+            Assert.AreEqual(10, interpreter.IntegerStack.Top);
+            Assert.IsTrue(interpreter.CodeStack.IsEmpty);
+            Assert.IsTrue(interpreter.ExecStack.IsEmpty);
+            Assert.IsTrue(interpreter.NameStack.IsEmpty);
+            Assert.IsTrue(interpreter.BooleanStack.IsEmpty);
+            Assert.IsTrue(interpreter.FloatStack.IsEmpty);
+        }
+
+        [TestMethod]
+        public void Example8()
+        {
+            this.interpreter.IntegerStack.Push(5);
+            this.interpreter.Interpret(@"( CODE.QUOTE ( INTEGER.POP 1 )
+                                           CODE.QUOTE ( CODE.DUP INTEGER.DUP 1 INTEGER.- CODE.DO INTEGER.* )
+                                           INTEGER.DUP 2 INTEGER.< CODE.IF )");
+
+            Assert.AreEqual(120, interpreter.IntegerStack.Top);
+            Assert.IsTrue(interpreter.CodeStack.IsEmpty);
+            Assert.IsTrue(interpreter.ExecStack.IsEmpty);
+            Assert.IsTrue(interpreter.NameStack.IsEmpty);
+            Assert.IsTrue(interpreter.BooleanStack.IsEmpty);
+            Assert.IsTrue(interpreter.FloatStack.IsEmpty);
+        }
+
+        [TestMethod]
+        public void Example9()
+        {
+            this.interpreter.IntegerStack.Push(5);
+            this.interpreter.Interpret("( 1 INTEGER.MAX 1 EXEC.DO*RANGE INTEGER.* )");
+
+            Assert.AreEqual(120, interpreter.IntegerStack.Top);
+            Assert.IsTrue(interpreter.CodeStack.IsEmpty);
+            Assert.IsTrue(interpreter.ExecStack.IsEmpty);
+            Assert.IsTrue(interpreter.NameStack.IsEmpty);
+            Assert.IsTrue(interpreter.BooleanStack.IsEmpty);
+            Assert.IsTrue(interpreter.FloatStack.IsEmpty);
+        }
+
+        [TestMethod]
+        public void Example10()
+        {
+            this.interpreter.IntegerStack.Push(5);
+            this.interpreter.Interpret("( 1 INTEGER.MAX 1 EXEC.DO*RANGE ( 2 INTEGER.* ) )");
+
+            Assert.AreEqual(32, interpreter.IntegerStack.Top);
+            Assert.IsTrue(interpreter.CodeStack.IsEmpty);
+            Assert.IsTrue(interpreter.ExecStack.IsEmpty);
+            Assert.IsTrue(interpreter.NameStack.IsEmpty);
+            Assert.IsTrue(interpreter.BooleanStack.IsEmpty);
+            Assert.IsTrue(interpreter.FloatStack.IsEmpty);
+        }
+
+        [TestMethod]
+        public void Example11()
+        {
+            var program = PushGPInterpreter.Encode("( INTEGER.= CODE.QUOTE FLOAT.* CODE.QUOTE FLOAT./ CODE.IF )");
+
+            this.interpreter.IntegerStack.Push(1, 1);
+            this.interpreter.FloatStack.Push(2.1, 0.7);
+
+            this.interpreter.Interpret(program);
+
+            Assert.IsTrue(interpreter.IntegerStack.IsEmpty);
+            Assert.AreEqual(1.47, interpreter.FloatStack.Top, Delta);
+            Assert.IsTrue(interpreter.CodeStack.IsEmpty);
+            Assert.IsTrue(interpreter.ExecStack.IsEmpty);
+            Assert.IsTrue(interpreter.NameStack.IsEmpty);
+            Assert.IsTrue(interpreter.BooleanStack.IsEmpty);
+
+            this.interpreter.Clear();
+            this.interpreter.IntegerStack.Push(1, 2);
+            this.interpreter.FloatStack.Push(2.1, 0.7);
+            this.interpreter.Interpret(program);
+
+            Assert.IsTrue(interpreter.IntegerStack.IsEmpty);
+            Assert.AreEqual(3d, interpreter.FloatStack.Top, Delta);
+            Assert.IsTrue(interpreter.CodeStack.IsEmpty);
+            Assert.IsTrue(interpreter.ExecStack.IsEmpty);
+            Assert.IsTrue(interpreter.NameStack.IsEmpty);
+            Assert.IsTrue(interpreter.BooleanStack.IsEmpty);
+        }
+
+        [TestMethod]
+        public void Example12()
+        {
+            var program = PushGPInterpreter.Encode("( INTEGER.= EXEC.IF FLOAT.* FLOAT./ )");
+
+            this.interpreter.IntegerStack.Push(1, 1);
+            this.interpreter.FloatStack.Push(2.1, 0.7);
+
+            this.interpreter.Interpret(program);
+
+            Assert.IsTrue(interpreter.IntegerStack.IsEmpty);
+            Assert.AreEqual(1.47, interpreter.FloatStack.Top, Delta);
+            Assert.IsTrue(interpreter.CodeStack.IsEmpty);
+            Assert.IsTrue(interpreter.ExecStack.IsEmpty);
+            Assert.IsTrue(interpreter.NameStack.IsEmpty);
+            Assert.IsTrue(interpreter.BooleanStack.IsEmpty);
+
+            this.interpreter.Clear();
+            this.interpreter.IntegerStack.Push(1, 2);
+            this.interpreter.FloatStack.Push(2.1, 0.7);
+            this.interpreter.Interpret(program);
+
+            Assert.IsTrue(interpreter.IntegerStack.IsEmpty);
+            Assert.AreEqual(3d, interpreter.FloatStack.Top, Delta);
+            Assert.IsTrue(interpreter.CodeStack.IsEmpty);
+            Assert.IsTrue(interpreter.ExecStack.IsEmpty);
+            Assert.IsTrue(interpreter.NameStack.IsEmpty);
+            Assert.IsTrue(interpreter.BooleanStack.IsEmpty);
+        }
+
+        [TestMethod]
+        public void Example13()
+        {
+            this.interpreter.IntegerStack.Push(5);
+            this.interpreter.Interpret("( EXEC.Y ( ( FALSE 2 INTEGER.* ) EXEC.IF ( ) EXEC.POP ) )");
+
+            Assert.AreEqual(10, interpreter.IntegerStack.Top);
+            Assert.IsTrue(interpreter.CodeStack.IsEmpty);
+            Assert.IsTrue(interpreter.ExecStack.IsEmpty);
+            Assert.IsTrue(interpreter.NameStack.IsEmpty);
+            Assert.IsTrue(interpreter.BooleanStack.IsEmpty);
+            Assert.IsTrue(interpreter.FloatStack.IsEmpty);
+        }
+
+        [TestMethod]
+        public void Example14()
+        {
+            this.interpreter.IntegerStack.Push(5);
+            this.interpreter.Interpret("( EXEC.Y ( ( 2 INTEGER.* INTEGER.DUP 1000 INTEGER.< ) EXEC.IF ( ) EXEC.POP ) )");
+
+            Assert.AreEqual(1280, interpreter.IntegerStack.Top);
+            Assert.IsTrue(interpreter.CodeStack.IsEmpty);
+            Assert.IsTrue(interpreter.ExecStack.IsEmpty);
+            Assert.IsTrue(interpreter.NameStack.IsEmpty);
+            Assert.IsTrue(interpreter.BooleanStack.IsEmpty);
+            Assert.IsTrue(interpreter.FloatStack.IsEmpty);
+        }
+
+        [TestMethod]
+        public void Example15()
+        {
+            this.interpreter.IntegerStack.Push(10);
+            this.interpreter.FloatStack.Push(2);
+            this.interpreter.Interpret(@"( ARG FLOAT.DEFINE
+                                            EXEC.Y (
+                                            ARG FLOAT.*
+                                            1 INTEGER.-
+                                            INTEGER.DUP 1 INTEGER.>
+                                            EXEC.IF ( ) EXEC.POP
+                                            )
+                                          )");
+
+            Assert.AreEqual(1024, interpreter.FloatStack.Top, Delta);
+            Assert.AreEqual(1, interpreter.IntegerStack.Top);
+            Assert.IsTrue(interpreter.CodeStack.IsEmpty);
+            Assert.IsTrue(interpreter.ExecStack.IsEmpty);
+            Assert.IsTrue(interpreter.NameStack.IsEmpty);
+            Assert.IsTrue(interpreter.BooleanStack.IsEmpty);
+        }
+    }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Expressions/ExecExpressionTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Expressions/ExecExpressionTests.cs	(revision 14328)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Expressions/ExecExpressionTests.cs	(revision 14328)
@@ -0,0 +1,10 @@
+﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+namespace HeuristicLab.Tests.Expressions
+{
+    [TestClass]
+    public class ExecExpressionTests : InterpreterTest
+    {
+
+    }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Expressions/FloatExpressionTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Expressions/FloatExpressionTests.cs	(revision 14328)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Expressions/FloatExpressionTests.cs	(revision 14328)
@@ -0,0 +1,10 @@
+﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+namespace HeuristicLab.Tests.Expressions
+{
+    [TestClass]
+    public class FloatExpressionTests : InterpreterTest
+    {
+
+    }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Expressions/IntegerExpressionTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Expressions/IntegerExpressionTests.cs	(revision 14328)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Expressions/IntegerExpressionTests.cs	(revision 14328)
@@ -0,0 +1,34 @@
+﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+namespace HeuristicLab.Tests.Expressions
+{
+    [TestClass]
+    public class IntegerExpressionTests : InterpreterTest
+    {
+        [TestMethod]
+        public void TestAdd()
+        {
+            interpreter.Interpret("( 5 5 INTEGER.+ )");
+
+            Assert.AreEqual(10, interpreter.IntegerStack.Top);
+            Assert.IsTrue(interpreter.CodeStack.IsEmpty);
+            Assert.IsTrue(interpreter.ExecStack.IsEmpty);
+            Assert.IsTrue(interpreter.NameStack.IsEmpty);
+            Assert.IsTrue(interpreter.BooleanStack.IsEmpty);
+            Assert.IsTrue(interpreter.FloatStack.IsEmpty);
+        }
+
+        [TestMethod]
+        public void TestSubtract()
+        {
+            interpreter.Interpret("( 10 5 INTEGER.- )");
+
+            Assert.AreEqual(5, interpreter.IntegerStack.Top);
+            Assert.IsTrue(interpreter.CodeStack.IsEmpty);
+            Assert.IsTrue(interpreter.ExecStack.IsEmpty);
+            Assert.IsTrue(interpreter.NameStack.IsEmpty);
+            Assert.IsTrue(interpreter.BooleanStack.IsEmpty);
+            Assert.IsTrue(interpreter.FloatStack.IsEmpty);
+        }
+    }
+}
